DELAYMS 1000
DEVICE 16F876
DECLARE XTAL 4
DECLARE ADIN_RES 10
DECLARE ADIN_STIME 50
'DECLARE ADIN_TAD = FRC
TRISB = %00111100
PORTB=0
TRISC=0
PORTC=0
'trisa=0
'porta=0
OPTION_REG.7=0
SYMBOL  Common= PORTA
SYMBOL  Seg7 =  PORTC
SYMBOL  Sbros = PORTB.3
SYMBOL  Motor = PORTB.4
SYMBOL  Enter = PORTB.5
SYMBOL  Led0 =  PORTB.6
SYMBOL  Led1 =  PORTB.7

DIM Time        AS  DWORD
DIM SecMin      AS  Time.LOWWORD
DIM Second      AS  SecMin.LOWBYTE
DIM Minut       AS  SecMin.HIGHBYTE
DIM Hour        AS  Time.HIGHWORD

DIM Second0     AS  BYTE
DIM Minut0      AS  BYTE
DIM OldSec      AS  BYTE
DIM Digit       AS  BYTE    '   
DIM Joker       AS  BYTE
DIM Joker1      AS  BYTE
DIM i           AS  BYTE
DIM j           AS  BYTE
DIM k           AS  BYTE
DIM ButtonPress AS  BYTE
DIM EAdres      AS  BYTE
DIM CommonBIT   AS  BIT     'OA=1, OK=0
DIM LastDot     AS  BIT
DIM Dot         AS  BIT     '
DIM DS13bit     AS  BIT     'DS1302 - 1, DS1307 - 0
DIM ScaleBit    AS  BIT

CLEAR
DIM DigPause    AS  2;4;10
'Led0=0
'Led1=0
'------- DS1302  DS1307---------------
SYMBOL  CLK =   PORTB.0     'SCLK  DS1302
SYMBOL  DTA =   PORTB.1     'I/O  DS1302
SYMBOL  RST=    PORTB.2     'RST  DS1302
IF RST=0 THEN
    DS13bit = 0
    SCL_PIN =   CLK         'DS1307 SCL pin
    SDA_PIN =   DTA         'DS1307 SDA pin
ELSE
    DS13bit = 1
    OUTPUT RST
    RST=0
ENDIF    

'------    ----------------------
TRISA=%00001000
'ADCON1=0
ADCON0.0=1
ADCON1=%10000000
Seg7.7=0
IF ADIN 3 < 512 THEN CommonBIT=1: ELSE: CommonBIT=0
DELAYMS 10    
'ALL_DIGITAL = true
OUTPUT PORTA.3  'TRISA = 0
'PORTA=0

' 2       
Second=88
Minut=88
Hour=8888
Dot= ~CommonBIT
FOR j=0 TO 100
    GOSUB ShowLeds 
NEXT
    
IF Motor=0 THEN
    Led0=1
    Led1=0
    EAdres=1
ELSE 
    Led1=1
    Led0=0
    EAdres=5
ENDIF
Time=EREAD EAdres
'Second=EREAD EAdres    
'Minut=EREAD EAdres + 1    
'Hour=EREAD EAdres + 2    
DELAYMS 50

'Second=55
'Minut=59
'Hour=0    
        
IF DS13bit=1 THEN
    GOSUB Write_DS1302
ELSE
    GOSUB Write_DS1307
ENDIF

'------- -------
MAIN:
    OldSec = Second
    
labTime:
    GOSUB Kak_DS13
    
    IF Enter=0 THEN
'        Led0=0
'        Led1=0
        PORTA.3=1
'        PORTB=0
        IF Second=0 THEN Second=1
'        IF Motor=0 THEN EAdres=1 : ELSE : EAdres=5
        EWRITE EAdres, [Time]
        DELAYMS 20
        
'        GOSUB Kak_Sbros
'                FOR j=0 TO 255
'                    GOSUB ShowLeds
'                NEXT j
'        END
        STOP
'        DELAYMS 2000    '<<<<<
    ENDIF
    IF Hour=9999 THEN 
        Time=0
'        Second=0
'        Minut=0
'        Hour=0
        GOSUB Kak_Sbros 
    ENDIF
    GOSUB DaviNaSbros
        
    IF Second.0 <> LastDot THEN
'        if CommonBIT=1 then dot=0 : else : dot=1 'Dot=1  , Dot=0  OA
        Dot= ~CommonBIT
        INC k
        IF k=20 THEN 
            k=0
            LastDot=Second.0
        ENDIF
    ELSE
'        IF CommonBIT=1 THEN Dot=1 : ELSE : Dot=0 'Dot=0  , Dot=1  OA
        Dot=CommonBIT
    ENDIF
'   Dot= Second.0
     
    GOSUB ShowLeds
    
    IF Second = OldSec THEN
        GOTO labTime
    ELSE 
'        IF Minut = 59 AND Second = 59 THEN INC Hour
        IF Minut + Second = 0 THEN INC Hour        
        GOTO MAIN
    ENDIF

'------------------------- :--------------------------

Fix_bcd_in:
    Joker1 = Joker & 15
    Joker = Joker >> 4
    Joker = 10 * Joker
    Joker = Joker1 + Joker
RETURN

Fix_bcd_out:
    Joker1 = Joker / $A 
    Joker = Joker - (Joker1 * $A) 
    Joker = Joker + (Joker1 << 4)
RETURN

Read_DS1302:
    RST=1
	SHOUT  DTA, CLK, LSBFIRST, [%111111\6,%10\2]
	SHIN   DTA, CLK, LSBPRE,   [Second0,Minut0]',Hour0]',Date,Month,Day,Year]
	RST=0
	
    Joker = Second0
    GOSUB Fix_bcd_in    '   
    Second = Joker
      
    Joker = Minut0
    GOSUB Fix_bcd_in
    Minut = Joker
RETURN

Write_DS1302:
    Joker = Second    
    GOSUB Fix_bcd_out                            
    Second0 = Joker
    
    Joker = Minut    
    GOSUB Fix_bcd_out                            
    Minut0 = Joker
    
    RST =1
    SHOUT DTA, CLK, LSBFIRST, [$8e, 0]  ;   ,  DS  
    RST =0
    
    RST=1
    IF Second0.7=1 THEN Second0.7=0 ;   
	SHOUT DTA,CLK,LSBFIRST,[$be,Second0,Minut0,1,1,1,1,1, 0]',Hour0]
'	SHOUT DTA,CLK,LSBFIRST,[$be,SECOND,MINUTE,HOUR,DATE,MONTH,DAY,YEAR,0]
    RST=0
RETURN

Read_DS1307:
    BSTART
    BUSIN $D0, 0, [Second0,Minut0]', 0,0,0,0,0]' Minut0,Minut0,Minut0,Minut0,Minut0]
    BSTOP
     
    Joker = Second0
    GOSUB Fix_bcd_in
    Second = Joker
      
    Joker = Minut0
    GOSUB Fix_bcd_in
    Minut = Joker
RETURN

Write_DS1307:
    Joker = Second    
    GOSUB Fix_bcd_out                            
    Second0 = Joker
    
    Joker = Minut    
    GOSUB Fix_bcd_out                            
    Minut0 = Joker
    
    BSTART
    BUSOUT $D1, 0, [Second0,Minut0,0,0,0,0,0]
'   BUSOUT $D1, 0, [Second,Minut,Hour,Day,Date,Month,Year]
    BSTOP
RETURN

Kak_DS13:
    IF DS13bit=1 THEN GOSUB Read_DS1302 : ELSE : GOSUB Read_DS1307
RETURN

IsDigit:
;         
;     
;156 -   
;%10111111 - (11)
;%11001000 - (13)
;%10001100 - (14)
;%10010001 - (12)
;%11000110 - C(15)
;%10000010 - (16)
;%10110110 -  (17)
Joker=LOOKUPL Digit,[192,249,164,176,153,146,130,248,128,144,156, _
%10111111,%10010001,%11001000,%10001100,%11000110,%10000010,%10110110]
RETURN

ShowDigit:
    GOSUB IsDigit
    IF CommonBIT=1 THEN Seg7=Joker: ELSE: Seg7= ~Joker
SubDel:
    DELAYMS DigPause    ;   
'    IF CommonBIT=1 THEN Seg7=255: ELSE: Seg7=0
    Seg7 = CommonBIT * 255
RETURN

Kak_CommonBIT:
    IF CommonBIT=1 THEN
        Common= Joker
    ELSE 
        Common= ~Joker
    ENDIF
RETURN

ShowLeds:
    IF ScaleBit=1 THEN
        FOR i=3 TO 0 STEP -1
            Joker= %00000001 << i
            Digit = Hour DIG i
            GOSUB Kak_CommonBIT
            GOSUB ShowDigit
        NEXT
    ELSE
        Joker= %00001000
        Digit = Hour DIG 1
        GOSUB Kak_CommonBIT
        GOSUB ShowDigit
        
        Joker= %00000100
        Digit = Hour DIG 0
        GOSUB Kak_CommonBIT
        GOSUB ShowDigit
        
        Joker= %00000010
        Digit = Minut DIG 1
        GOSUB Kak_CommonBIT
        GOSUB ShowDigit
        
        Joker= %00000001
        Digit = Minut DIG 0
        GOSUB Kak_CommonBIT
        GOSUB ShowDigit     
    ENDIF
'      
    IF ScaleBit=1 THEN
        Joker= %00000001    '   4-  
    ELSE
        Joker= %00000100    '   4-  
    ENDIF
    Seg7.7=Dot
    GOSUB Kak_CommonBIT
    GOSUB SubDel 
RETURN                

Kak_Sbros:
    IF Motor=0 THEN EAdres=1 : ELSE : EAdres=5
    IF Second=0 THEN Second=1
    EWRITE EAdres, [Time]
'    EWRITE EAdres, [Second,Minut,Hour]
    DELAYMS 10
    IF DS13bit=1 THEN GOSUB Write_DS1302 : ELSE : GOSUB Write_DS1307
RETURN

DaviNaSbros:
	ButtonPress=0
	WHILE Sbros=0  '       <>
		IF ButtonPress < 255 THEN INC ButtonPress
		DELAYMS 20
        IF ButtonPress > 20 THEN
            FOR j=0 TO 100
                FOR i=3 TO 0 STEP -1
                    Digit=LOOKUPL i,[15,0,14,16]    ;
                    Joker= %00000001 << i
                    GOSUB Kak_CommonBIT
                    GOSUB ShowDigit 
                NEXT
            NEXT
            Time=0
'            Second=0
'            Minut=0
'            Hour=0
            GOSUB Kak_Sbros
            DELAYMS 500
        ELSE
            ScaleBit= ~ScaleBit
            DELAYMS 50 
        ENDIF 
	WEND
RETURN

END


